package beispiel;

import annotation.MeinTest;

public class Beispiel {
    
    @MeinTest
    public void test1(){
    }
    
    @MeinTest(erlaubt={ArithmeticException.class})
    protected void test2(){
        if (6*9 != 42){
            throw new ArithmeticException("stimmt die Frage nicht");
        }
    }
    
    @MeinTest(erlaubt=NumberFormatException.class)
    private void test3(){
    }
    
    @MeinTest(erlaubt={NumberFormatException.class
            ,ArithmeticException.class})
    void test4() throws Exception{
        throw new Exception("immerhin ausgefuehrt");
    }
    
    @MeinTest
    public static void test5(){
    }
    
    public void keineTestmethodeMussErlaubtSein() {
    	
    }
    
    @MeinTest
    public int testkeinTestMitRueckgabetyp(){
    	return 43;
    }
    
    //////////////////////////////////
    
    @MeinTest
    public void testkeinTestDaParameterlisteOhneDatei(int x){
    }
    
    @MeinTest(datei="Testdaten.csv")
    public void testkeinTestDaKeineParameterlisteMitDatei(){
    }
    
    @MeinTest(datei="nichtLesbar.txt")
    public void testkeinTestDaDateiNichtLesbar(int x){
    }
       
    @MeinTest(datei="NichDa.csv")
    public void testMitNichtExistierenderDatei(String s1) {
    	
    }
    
    @MeinTest(datei="src")
    public void testMitNichtNutzbaremVerzeichnis(String s1) {
    	
    }
     
    @MeinTest(datei="Testdaten.csv")
    public void testMitDatei(String s1, String s2, int i, boolean b) 
    		throws Exception{
    	if (s1.equals(s2 + i) != b) {
    		throw new Exception(s1 + " eq " + s2 + i + " sollte " 
    	                        + (b ? "wahr sein" : "falsch sein"));
    	}
    }
    
    @MeinTest(datei="Testdaten2.csv", erlaubt=IllegalArgumentException.class)
    public void testMitDateiUndException(double wert1, int grenze, boolean exceptionerwartet) {
    	boolean fehler = false;
    	if( wert1 > grenze) {
    		fehler = true;
    	}
    	if (fehler && exceptionerwartet) {
    		throw new IllegalArgumentException("zu gross");
    	}
    	if ((fehler && !exceptionerwartet) || (!fehler && exceptionerwartet)) {
    		throw new InternalError("allgemeiner Fehler");
    	}
    }
}
